%global gem_name    puppet-lint
%global _name       rubygem-%{gem_name}
%global _version    0.3.2

%if 0%{?rhel} == 5
%global gem_dir     %(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
%endif

Name:               %{_name}
Version:            %{_version}
Release:            1%{?dist}
Summary:            Check that your Puppet manifest conform to the style guide
Group:              Development/Languages
License:            MIT
URL:                http://rubygems.org/gems/%{gem_name}
Source0:            http://rubygems.org/downloads/%{gem_name}-%{version}.gem

BuildRoot:          %{_tmppath}/%{name}-%{version}-%{release}-%(id -un)
BuildArch:          noarch


%if 0%{?rhel} == 5
BuildRequires:      ruby(rubygems)
Requires:           ruby(abi)
Requires:           rubygems
Provides:           rubygem(%{gem_name}) = %{version}-%{release}
%else
BuildRequires:      rubygems-devel
Requires:           rubygems
%endif

%description
The goal of this project is to implement as many of the recommended Puppet
style guidelines from the Puppet Labs style guide as practical. It is not
meant to validate syntax. Please use puppet parser validate for that.

%prep
gem unpack %{SOURCE0}
%setup -q -D -T -n  %{gem_name}-%{version}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

%build
gem build %{gem_name}.gemspec
%if 0%{?rhel} == 5
mkdir -p ./%{gem_dir}
gem install \
       --local \
       --install-dir ./%{gem_dir} \
       --force \
       --rdoc \
       -V \
       %{SOURCE0}
%else
# Create the gem as gem install only works on a gem file

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gem_dir}
cp -a ./%{gem_dir}/* %{buildroot}%{gem_dir}/

# If there were programs installed:
mkdir -p %{buildroot}%{_bindir}
%if 0%{?rhel} == 5
mv %{buildroot}%{gem_dir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gem_dir}/bin
%else
cp -a ./%{_bindir}/* %{buildroot}%{_bindir}
%endif

# We don't want to ship these files
rm %{buildroot}%{gem_dir}/gems/%{gem_name}-%{version}/.gitignore
rm %{buildroot}%{gem_dir}/gems/%{gem_name}-%{version}/.travis.yml

# Fix shebang for bin.rb
sed -i -e "1i#!%{_bindir}/ruby" %{buildroot}%{gem_dir}/gems/%{gem_name}-%{version}/lib/%{gem_name}/bin.rb



%files
%{_bindir}/%{gem_name}
%{gem_dir}/gems/%{gem_name}-%{version}/
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%doc %{gem_dir}/doc/%{gem_name}-%{version}

%changelog
* Fri Jul 18 2014 Melissa Stone <melissa@puppetlabs.com> - 0.3.2-1
- Initial packaging for {apt,yum}.puppetlabs.com
